##// END OF EJS Templates
fix --exclude
Unknown -
r276:cd8c0133097d
parent child
Show More
@@ -1,783 +1,783
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 20+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45
46 46 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
47 47 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
48 48 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
49 49
50 50 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
51 51 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
52 52 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
53 53
54 54 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
55 55 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
56 56 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
57 57
58 58 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
59 59 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
60 60 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
61 61
62 62 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
63 63 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
64 64 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
65 65
66 66 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
67 67 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
68 68 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
69 69
70 70 # Debian release
71 71 RELEASE=${RELEASE:=jessie}
72 72 KERNEL_ARCH=${KERNEL_ARCH:=arm}
73 73 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
74 74 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
75 75 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
76 76 if [ "$KERNEL_ARCH" = "arm64" ] ; then
77 77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
78 78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
79 79 fi
80 80
81 81 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
82 82 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
83 83 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
84 84 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
85 85 else
86 86 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
87 87 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
88 88 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
89 89 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
90 90 fi
91 91
92 92 if [ "$RELEASE_ARCH" = "arm64" ] ; then
93 93 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
94 94 else
95 95 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
96 96 fi
97 97 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
98 98
99 99 # URLs
100 100 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
101 101 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
102 102 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
103 103 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
104 104 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
105 105 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
106 106
107 107 # Build directories
108 108 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
109 109 BUILDDIR="${BASEDIR}/build"
110 110
111 111 # Prepare date string for default image file name
112 112 DATE="$(date +%Y-%m-%d)"
113 113 if [ -z "$KERNEL_BRANCH" ] ; then
114 114 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
115 115 else
116 116 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
117 117 fi
118 118
119 119 # Chroot directories
120 120 R="${BUILDDIR}/chroot"
121 121 ETC_DIR="${R}/etc"
122 122 LIB_DIR="${R}/lib"
123 123 BOOT_DIR="${R}/boot/firmware"
124 124 KERNEL_DIR="${R}/usr/src/linux"
125 125 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
126 126
127 127 # Firmware directory: Blank if download from github
128 128 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
129 129
130 130 # General settings
131 131 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
132 132 PASSWORD=${PASSWORD:=raspberry}
133 133 USER_PASSWORD=${USER_PASSWORD:=raspberry}
134 134 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
135 135 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
136 136 EXPANDROOT=${EXPANDROOT:=true}
137 137
138 138 # Keyboard settings
139 139 XKB_MODEL=${XKB_MODEL:=""}
140 140 XKB_LAYOUT=${XKB_LAYOUT:=""}
141 141 XKB_VARIANT=${XKB_VARIANT:=""}
142 142 XKB_OPTIONS=${XKB_OPTIONS:=""}
143 143
144 144 # Network settings (DHCP)
145 145 ENABLE_DHCP=${ENABLE_DHCP:=true}
146 146
147 147 # Network settings (static)
148 148 NET_ADDRESS=${NET_ADDRESS:=""}
149 149 NET_GATEWAY=${NET_GATEWAY:=""}
150 150 NET_DNS_1=${NET_DNS_1:=""}
151 151 NET_DNS_2=${NET_DNS_2:=""}
152 152 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
153 153 NET_NTP_1=${NET_NTP_1:=""}
154 154 NET_NTP_2=${NET_NTP_2:=""}
155 155
156 156 # APT settings
157 157 APT_PROXY=${APT_PROXY:=""}
158 158 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
159 159
160 160 # Feature settings
161 161 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
162 162 ENABLE_I2C=${ENABLE_I2C:=false}
163 163 ENABLE_SPI=${ENABLE_SPI:=false}
164 164 ENABLE_IPV6=${ENABLE_IPV6:=true}
165 165 ENABLE_SSHD=${ENABLE_SSHD:=true}
166 166 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
167 167 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
168 168 ENABLE_SOUND=${ENABLE_SOUND:=true}
169 169 ENABLE_DBUS=${ENABLE_DBUS:=true}
170 170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 172 ENABLE_XORG=${ENABLE_XORG:=false}
173 173 ENABLE_WM=${ENABLE_WM:=""}
174 174 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
175 175 ENABLE_USER=${ENABLE_USER:=true}
176 176 USER_NAME=${USER_NAME:="pi"}
177 177 ENABLE_ROOT=${ENABLE_ROOT:=false}
178 178 ENABLE_QEMU=${ENABLE_QEMU:=false}
179 179 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
180 180
181 181 # SSH settings
182 182 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
183 183 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
184 184 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
185 185 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
186 186 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
187 187
188 188 # Advanced settings
189 189 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
190 190 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
191 191 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
192 192 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
193 193 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
194 194 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
195 195 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
196 196 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
197 197 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
198 198 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
199 199 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
200 200 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
201 201
202 202 # Kernel compilation settings
203 203 BUILD_KERNEL=${BUILD_KERNEL:=false}
204 204 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
205 205 KERNEL_THREADS=${KERNEL_THREADS:=1}
206 206 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
207 207 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
208 208 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
209 209 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
210 210 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
211 211
212 212 if [ "$KERNEL_ARCH" = "arm64" ] ; then
213 213 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
214 214 else
215 215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
216 216 fi
217 217
218 218 # Kernel compilation from source directory settings
219 219 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
220 220 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
221 221 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
222 222 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
223 223
224 224 # Reduce disk usage settings
225 225 REDUCE_APT=${REDUCE_APT:=true}
226 226 REDUCE_DOC=${REDUCE_DOC:=true}
227 227 REDUCE_MAN=${REDUCE_MAN:=true}
228 228 REDUCE_VIM=${REDUCE_VIM:=false}
229 229 REDUCE_BASH=${REDUCE_BASH:=false}
230 230 REDUCE_HWDB=${REDUCE_HWDB:=true}
231 231 REDUCE_SSHD=${REDUCE_SSHD:=true}
232 232 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
233 233
234 234 # Encrypted filesystem settings
235 235 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
236 236 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
237 237 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
238 238 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
239 239 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
240 240
241 241 # Chroot scripts directory
242 242 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
243 243
244 244 # Packages required in the chroot build environment
245 245 APT_INCLUDES=${APT_INCLUDES:=""}
246 246 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
247 247
248 248 #Packages to exclude from chroot build environment
249 249 APT_EXCLUDES=${APT_EXCLUDES:=""}
250 250
251 251 # Packages required for bootstrapping
252 252 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
253 253 MISSING_PACKAGES=""
254 254
255 255 # Packages installed for c/c++ build environment in chroot (keep empty)
256 256 COMPILER_PACKAGES=""
257 257
258 258 set +x
259 259
260 260 #If init and systemd-sysv are wanted e.g. halt/reboot/shutdown scripts
261 261 if [ "$ENABLE_SYSVINIT" = false ] ; then
262 APT_EXCLUDES="${APT_EXCLUDES},init,systemd-sysv"
262 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
263 263 fi
264 264
265 265 # Set Raspberry Pi model specific configuration
266 266 if [ "$RPI_MODEL" = 0 ] ; then
267 267 DTB_FILE=${RPI0_DTB_FILE}
268 268 UBOOT_CONFIG=${RPI0_UBOOT_CONFIG}
269 269 elif [ "$RPI_MODEL" = 1 ] ; then
270 270 DTB_FILE=${RPI1_DTB_FILE}
271 271 UBOOT_CONFIG=${RPI1_UBOOT_CONFIG}
272 272 elif [ "$RPI_MODEL" = 1P ] ; then
273 273 DTB_FILE=${RPI1P_DTB_FILE}
274 274 UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG}
275 275 elif [ "$RPI_MODEL" = 2 ] ; then
276 276 DTB_FILE=${RPI2_DTB_FILE}
277 277 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
278 278 elif [ "$RPI_MODEL" = 3 ] ; then
279 279 DTB_FILE=${RPI3_DTB_FILE}
280 280 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
281 281 elif [ "$RPI_MODEL" = 3P ] ; then
282 282 DTB_FILE=${RPI3P_DTB_FILE}
283 283 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
284 284 else
285 285 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
286 286 exit 1
287 287 fi
288 288
289 289 # Check if the internal wireless interface is supported by the RPi model
290 290 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]); then
291 291
292 292 echo "error: The selected Raspberry Pi model has no internal wireless interface"
293 293 exit 1
294 294 fi
295 295
296 296 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
297 297 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
298 298 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
299 299 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
300 300 exit 1
301 301 fi
302 302 fi
303 303
304 304 # Build RPi2/3 Linux kernel if required by Debian release
305 305 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
306 306 BUILD_KERNEL=true
307 307 fi
308 308
309 309 # Add packages required for kernel cross compilation
310 310 if [ "$BUILD_KERNEL" = true ] ; then
311 311 if [ "$KERNEL_ARCH" = "arm" ] ; then
312 312 if [ "$RELEASE_ARCH" = "armel" ]; then
313 313 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
314 314 fi
315 315 if [ "$RELEASE_ARCH" = "armhf" ]; then
316 316 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
317 317 fi
318 318 if [ "$RELEASE_ARCH" = "arm64" ]; then
319 319 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
320 320 fi
321 321 fi
322 322 fi
323 323
324 324 # Add libncurses5 to enable kernel menuconfig
325 325 if [ "$KERNEL_MENUCONFIG" = true ] ; then
326 326 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
327 327 fi
328 328
329 329 # Add ccache compiler cache for (faster) kernel cross (re)compilation
330 330 if [ "$KERNEL_CCACHE" = true ] ; then
331 331 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
332 332 fi
333 333
334 334 # Add cryptsetup package to enable filesystem encryption
335 335 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
336 336 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
337 337 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
338 338
339 339 if [ -z "$CRYPTFS_PASSWORD" ] ; then
340 340 echo "error: no password defined (CRYPTFS_PASSWORD)!"
341 341 exit 1
342 342 fi
343 343 ENABLE_INITRAMFS=true
344 344 fi
345 345
346 346 # Add initramfs generation tools
347 347 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
348 348 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
349 349 fi
350 350
351 351 # Add device-tree-compiler required for building the U-Boot bootloader
352 352 if [ "$ENABLE_UBOOT" = true ] ; then
353 353 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
354 354 fi
355 355
356 356 # Check if root SSH (v2) public key file exists
357 357 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
358 358 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
359 359 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
360 360 exit 1
361 361 fi
362 362 fi
363 363
364 364 # Check if $USER_NAME SSH (v2) public key file exists
365 365 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
366 366 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
367 367 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
368 368 exit 1
369 369 fi
370 370 fi
371 371
372 372 # Check if all required packages are installed on the build system
373 373 for package in $REQUIRED_PACKAGES ; do
374 374 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
375 375 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
376 376 fi
377 377 done
378 378
379 379 # If there are missing packages ask confirmation for install, or exit
380 380 if [ -n "$MISSING_PACKAGES" ] ; then
381 381 echo "the following packages needed by this script are not installed:"
382 382 echo "$MISSING_PACKAGES"
383 383
384 384 echo -n "\ndo you want to install the missing packages right now? [y/n] "
385 385 read confirm
386 386 [ "$confirm" != "y" ] && exit 1
387 387
388 388 # Make sure all missing required packages are installed
389 389 apt-get -qq -y install ${MISSING_PACKAGES}
390 390 fi
391 391
392 392 # Check if ./bootstrap.d directory exists
393 393 if [ ! -d "./bootstrap.d/" ] ; then
394 394 echo "error: './bootstrap.d' required directory not found!"
395 395 exit 1
396 396 fi
397 397
398 398 # Check if ./files directory exists
399 399 if [ ! -d "./files/" ] ; then
400 400 echo "error: './files' required directory not found!"
401 401 exit 1
402 402 fi
403 403
404 404 # Check if specified KERNELSRC_DIR directory exists
405 405 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
406 406 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
407 407 exit 1
408 408 fi
409 409
410 410 # Check if specified UBOOTSRC_DIR directory exists
411 411 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
412 412 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
413 413 exit 1
414 414 fi
415 415
416 416 # Check if specified FBTURBOSRC_DIR directory exists
417 417 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
418 418 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
419 419 exit 1
420 420 fi
421 421
422 422 # Check if specified CHROOT_SCRIPTS directory exists
423 423 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
424 424 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
425 425 exit 1
426 426 fi
427 427
428 428 # Check if specified device mapping already exists (will be used by cryptsetup)
429 429 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
430 430 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
431 431 exit 1
432 432 fi
433 433
434 434 # Don't clobber an old build
435 435 if [ -e "$BUILDDIR" ] ; then
436 436 echo "error: directory ${BUILDDIR} already exists, not proceeding"
437 437 exit 1
438 438 fi
439 439
440 440 # Setup chroot directory
441 441 mkdir -p "${R}"
442 442
443 443 # Check if build directory has enough of free disk space >512MB
444 444 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
445 445 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
446 446 exit 1
447 447 fi
448 448
449 449 set -x
450 450
451 451 # Call "cleanup" function on various signals and errors
452 452 trap cleanup 0 1 2 3 6
453 453
454 454 # Add required packages for the minbase installation
455 455 if [ "$ENABLE_MINBASE" = true ] ; then
456 456 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
457 457 fi
458 458
459 459 # Add required locales packages
460 460 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
461 461 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
462 462 fi
463 463
464 464 # Add parted package, required to get partprobe utility
465 465 if [ "$EXPANDROOT" = true ] ; then
466 466 APT_INCLUDES="${APT_INCLUDES},parted"
467 467 fi
468 468
469 469 # Add dbus package, recommended if using systemd
470 470 if [ "$ENABLE_DBUS" = true ] ; then
471 471 APT_INCLUDES="${APT_INCLUDES},dbus"
472 472 fi
473 473
474 474 # Add iptables IPv4/IPv6 package
475 475 if [ "$ENABLE_IPTABLES" = true ] ; then
476 476 APT_INCLUDES="${APT_INCLUDES},iptables"
477 477 fi
478 478
479 479 # Add openssh server package
480 480 if [ "$ENABLE_SSHD" = true ] ; then
481 481 APT_INCLUDES="${APT_INCLUDES},openssh-server"
482 482 fi
483 483
484 484 # Add alsa-utils package
485 485 if [ "$ENABLE_SOUND" = true ] ; then
486 486 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
487 487 fi
488 488
489 489 # Add rng-tools package
490 490 if [ "$ENABLE_HWRANDOM" = true ] ; then
491 491 APT_INCLUDES="${APT_INCLUDES},rng-tools"
492 492 fi
493 493
494 494 # Add fbturbo video driver
495 495 if [ "$ENABLE_FBTURBO" = true ] ; then
496 496 # Enable xorg package dependencies
497 497 ENABLE_XORG=true
498 498 fi
499 499
500 500 # Add user defined window manager package
501 501 if [ -n "$ENABLE_WM" ] ; then
502 502 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
503 503
504 504 # Enable xorg package dependencies
505 505 ENABLE_XORG=true
506 506 fi
507 507
508 508 # Add xorg package
509 509 if [ "$ENABLE_XORG" = true ] ; then
510 510 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
511 511 fi
512 512
513 513 # Replace selected packages with smaller clones
514 514 if [ "$ENABLE_REDUCE" = true ] ; then
515 515 # Add levee package instead of vim-tiny
516 516 if [ "$REDUCE_VIM" = true ] ; then
517 517 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
518 518 fi
519 519
520 520 # Add dropbear package instead of openssh-server
521 521 if [ "$REDUCE_SSHD" = true ] ; then
522 522 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
523 523 fi
524 524 fi
525 525
526 526 if [ "$RELEASE" != "jessie" ] ; then
527 527 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
528 528 fi
529 529
530 530 # Configure kernel sources if no KERNELSRC_DIR
531 531 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
532 532 KERNELSRC_CONFIG=true
533 533 fi
534 534
535 535 # Configure reduced kernel
536 536 if [ "$KERNEL_REDUCE" = true ] ; then
537 537 KERNELSRC_CONFIG=false
538 538 fi
539 539
540 540 # Configure qemu compatible kernel
541 541 if [ "$ENABLE_QEMU" = true ] ; then
542 542 DTB_FILE=vexpress-v2p-ca15_a7.dtb
543 543 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
544 544 KERNEL_DEFCONFIG="vexpress_defconfig"
545 545 if [ "$KERNEL_MENUCONFIG" = false ] ; then
546 546 KERNEL_OLDDEFCONFIG=true
547 547 fi
548 548 fi
549 549
550 550 # Execute bootstrap scripts
551 551 for SCRIPT in bootstrap.d/*.sh; do
552 552 head -n 3 "$SCRIPT"
553 553 . "$SCRIPT"
554 554 done
555 555
556 556 ## Execute custom bootstrap scripts
557 557 if [ -d "custom.d" ] ; then
558 558 for SCRIPT in custom.d/*.sh; do
559 559 . "$SCRIPT"
560 560 done
561 561 fi
562 562
563 563 # Execute custom scripts inside the chroot
564 564 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
565 565 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
566 566 chroot_exec /bin/bash -x <<'EOF'
567 567 for SCRIPT in /chroot_scripts/* ; do
568 568 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
569 569 $SCRIPT
570 570 fi
571 571 done
572 572 EOF
573 573 rm -rf "${R}/chroot_scripts"
574 574 fi
575 575
576 576 # Remove c/c++ build environment from the chroot
577 577 chroot_remove_cc
578 578
579 579 # Remove apt-utils
580 580 if [ "$RELEASE" = "jessie" ] ; then
581 581 chroot_exec apt-get purge -qq -y --force-yes apt-utils
582 582 fi
583 583
584 584 # Generate required machine-id
585 585 MACHINE_ID=$(dbus-uuidgen)
586 586 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
587 587 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
588 588
589 589 # APT Cleanup
590 590 chroot_exec apt-get -y clean
591 591 chroot_exec apt-get -y autoclean
592 592 chroot_exec apt-get -y autoremove
593 593
594 594 # Unmount mounted filesystems
595 595 umount -l "${R}/proc"
596 596 umount -l "${R}/sys"
597 597
598 598 # Clean up directories
599 599 rm -rf "${R}/run/*"
600 600 rm -rf "${R}/tmp/*"
601 601
602 602 # Clean up files
603 603 rm -f "${ETC_DIR}/ssh/ssh_host_*"
604 604 rm -f "${ETC_DIR}/dropbear/dropbear_*"
605 605 rm -f "${ETC_DIR}/apt/sources.list.save"
606 606 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
607 607 rm -f "${ETC_DIR}/*-"
608 608 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
609 609 rm -f "${ETC_DIR}/resolv.conf"
610 610 rm -f "${R}/root/.bash_history"
611 611 rm -f "${R}/var/lib/urandom/random-seed"
612 612 rm -f "${R}/initrd.img"
613 613 rm -f "${R}/vmlinuz"
614 614 rm -f "${R}${QEMU_BINARY}"
615 615
616 616 if [ "$ENABLE_QEMU" = true ] ; then
617 617 # Setup QEMU directory
618 618 mkdir "${BASEDIR}/qemu"
619 619
620 620 # Copy kernel image to QEMU directory
621 621 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
622 622
623 623 # Copy kernel config to QEMU directory
624 624 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
625 625
626 626 # Copy kernel dtbs to QEMU directory
627 627 for dtb in "${BOOT_DIR}/"*.dtb ; do
628 628 if [ -f "${dtb}" ] ; then
629 629 install_readonly "${dtb}" "${BASEDIR}/qemu/"
630 630 fi
631 631 done
632 632
633 633 # Copy kernel overlays to QEMU directory
634 634 if [ -d "${BOOT_DIR}/overlays" ] ; then
635 635 # Setup overlays dtbs directory
636 636 mkdir "${BASEDIR}/qemu/overlays"
637 637
638 638 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
639 639 if [ -f "${dtb}" ] ; then
640 640 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
641 641 fi
642 642 done
643 643 fi
644 644
645 645 # Copy u-boot files to QEMU directory
646 646 if [ "$ENABLE_UBOOT" = true ] ; then
647 647 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
648 648 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
649 649 fi
650 650 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
651 651 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
652 652 fi
653 653 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
654 654 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
655 655 fi
656 656 fi
657 657
658 658 # Copy initramfs to QEMU directory
659 659 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
660 660 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
661 661 fi
662 662 fi
663 663
664 664 # Calculate size of the chroot directory in KB
665 665 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
666 666
667 667 # Calculate the amount of needed 512 Byte sectors
668 668 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
669 669 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
670 670 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
671 671
672 672 # The root partition is EXT4
673 673 # This means more space than the actual used space of the chroot is used.
674 674 # As overhead for journaling and reserved blocks 35% are added.
675 675 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
676 676
677 677 # Calculate required image size in 512 Byte sectors
678 678 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
679 679
680 680 # Prepare image file
681 681 if [ "$ENABLE_SPLITFS" = true ] ; then
682 682 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
683 683 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
684 684 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
685 685 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
686 686
687 687 # Write firmware/boot partition tables
688 688 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
689 689 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
690 690 EOM
691 691
692 692 # Write root partition table
693 693 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
694 694 ${TABLE_SECTORS},${ROOT_SECTORS},83
695 695 EOM
696 696
697 697 # Setup temporary loop devices
698 698 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
699 699 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
700 700 else # ENABLE_SPLITFS=false
701 701 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
702 702 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
703 703
704 704 # Write partition table
705 705 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
706 706 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
707 707 ${ROOT_OFFSET},${ROOT_SECTORS},83
708 708 EOM
709 709
710 710 # Setup temporary loop devices
711 711 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
712 712 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
713 713 fi
714 714
715 715 if [ "$ENABLE_CRYPTFS" = true ] ; then
716 716 # Create dummy ext4 fs
717 717 mkfs.ext4 "$ROOT_LOOP"
718 718
719 719 # Setup password keyfile
720 720 touch .password
721 721 chmod 600 .password
722 722 echo -n ${CRYPTFS_PASSWORD} > .password
723 723
724 724 # Initialize encrypted partition
725 725 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
726 726
727 727 # Open encrypted partition and setup mapping
728 728 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
729 729
730 730 # Secure delete password keyfile
731 731 shred -zu .password
732 732
733 733 # Update temporary loop device
734 734 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
735 735
736 736 # Wipe encrypted partition (encryption cipher is used for randomness)
737 737 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
738 738 fi
739 739
740 740 # Build filesystems
741 741 mkfs.vfat "$FRMW_LOOP"
742 742 mkfs.ext4 "$ROOT_LOOP"
743 743
744 744 # Mount the temporary loop devices
745 745 mkdir -p "$BUILDDIR/mount"
746 746 mount "$ROOT_LOOP" "$BUILDDIR/mount"
747 747
748 748 mkdir -p "$BUILDDIR/mount/boot/firmware"
749 749 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
750 750
751 751 # Copy all files from the chroot to the loop device mount point directory
752 752 rsync -a "${R}/" "$BUILDDIR/mount/"
753 753
754 754 # Unmount all temporary loop devices and mount points
755 755 cleanup
756 756
757 757 # Create block map file(s) of image(s)
758 758 if [ "$ENABLE_SPLITFS" = true ] ; then
759 759 # Create block map files for "bmaptool"
760 760 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
761 761 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
762 762
763 763 # Image was successfully created
764 764 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
765 765 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
766 766 else
767 767 # Create block map file for "bmaptool"
768 768 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
769 769
770 770 # Image was successfully created
771 771 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
772 772
773 773 # Create qemu qcow2 image
774 774 if [ "$ENABLE_QEMU" = true ] ; then
775 775 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
776 776 QEMU_SIZE=16G
777 777
778 778 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
779 779 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
780 780
781 781 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
782 782 fi
783 783 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant